using System;
using System.Windows.Forms;
using System.Diagnostics;
using System.ServiceModel;

namespace Client
{
   public partial class MyClient : Form
   {
      public MyClient()
      {
         InitializeComponent();
      }

      void OnCall(object sender,EventArgs e)
      {
         string endpointName = GetEndpointName();
         MyContractClient proxy = new MyContractClient(endpointName);

         try
         {
            proxy.MethodWithError();
         }
         catch(FaultException<DivideByZeroException> exception)
         {
            Trace.WriteLine("First call: " + exception.GetType() + " " + exception.Message);
         }
         catch(FaultException exception)
         {
            Trace.WriteLine("First call: " + exception.GetType() + " " + exception.Message);
         }
         catch(CommunicationException exception)
         {
            Trace.WriteLine("First call: " + exception.GetType() + " " + exception.Message);
         }
         catch(Exception exception)
         {
            Trace.WriteLine("First call: " + exception.GetType() + " " + exception.Message);
         }
         try
         {
            proxy.MethodWithoutError();
         }
         catch(Exception exception)
         {
            Trace.WriteLine("Second call: " + exception.GetType() + " " + exception.Message);
         }
         proxy.Close();
      }

      string GetEndpointName()
      {
         if(m_HttpRadioButton.Checked)
         {
            return "HTTP";
         }
         if(m_TcpRadioButton.Checked)
         {
            return "TCP";
         }
         if(m_IpcRadioButton.Checked)
         {
            return "IPC";
         }
         throw new InvalidOperationException();
      }
   }
}



