using System;
using System.Messaging;
using System.ServiceModel;

namespace Fabrikam
{
    public class Program
    {
        private const string queueName = @".\private$\traderecording";

        public static void Main( string[ ] args )
        {
            if ( !( MessageQueue.Exists( queueName ) ) )
            {
                MessageQueue.Create( queueName, true );
            }

            TradeRecorder tradeRecorder = new TradeRecorder( );
            using ( ServiceHost host = new ServiceHost( tradeRecorder ) )
            {
                host.Open( );
                Console.WriteLine( "The trade recording service is available." );
                Console.ReadKey( );
            }
        }
    }
}