using System;
using System.Collections.Generic;
using System.Text;
using Common;
using System.ServiceModel;

namespace Client
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Press enter");
            Console.ReadLine();

            InvokeWithRemoting();

            Console.WriteLine();
            Console.WriteLine("Press enter");
            Console.ReadLine();

            InvokeWithWCF();

            Console.WriteLine();
            Console.WriteLine("Done");
            Console.ReadLine();
        }

        private static void InvokeWithRemoting()
        {
            Console.WriteLine("Invoking a service with .NET Remoting");
            
            OperationData data = new OperationData();
            data.Value = "Remoting invocation";

            IService svc = (IService)Activator.GetObject(typeof(IService),
              "http://localhost:8080/Service.rem");

            svc.Operation(data);
        }

        private static void InvokeWithWCF()
        {
            Console.WriteLine("Invoking a service with WCF");

            OperationData data = new OperationData();
            data.Value = "WCF invocation";

            ChannelFactory<IService> fact = new ChannelFactory<IService>("service");
            IService svc = fact.CreateChannel();

            svc.Operation(data);
        }
    }
}
