using System;
using System.ServiceModel;
using System.Windows.Forms;
using Service;

namespace Client
{
    public partial class mainForm : Form
    {
        public mainForm()
        {
            InitializeComponent();
        }

        private void btnGetIdentity_Click(object sender, EventArgs e)
        {
            try
            {
                ISecuredService svc = CreateServiceProxy();
                string identityName = svc.GetMyIdentity();

                MessageBox.Show(string.Format("Your identity is {0}", identityName));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnDoSomethingAsAdministrator_Click(object sender, EventArgs e)
        {
            try
            {
                ISecuredService svc = CreateServiceProxy();
                string result = svc.DoSomethingAsAdministrator();

                MessageBox.Show(string.Format("Secured Service returns {0}", result));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnDoSomethingAsUser_Click(object sender, EventArgs e)
        {
            try
            {
                ISecuredService svc = CreateServiceProxy();
                string result = svc.DoSomethingAsRegularUser();

                MessageBox.Show(string.Format("Secured Service returns {0}", result));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private ISecuredService CreateServiceProxy()
        {
            ChannelFactory<ISecuredService> securedServiceChannelFactory =
                new ChannelFactory<ISecuredService>("SecuredService");

            //
            // Credentials to present to the STS service
            //
            securedServiceChannelFactory.Credentials.UserName.UserName =
                @"nomad2\userb";
            securedServiceChannelFactory.Credentials.UserName.Password =
                "test11$";

            return securedServiceChannelFactory.CreateChannel();
        }
    }
}