using System.ComponentModel;
using System.Configuration;
using System.Security.Cryptography.X509Certificates;

namespace SecurityTokenService.Configuration
{
    public class SecurityCertificateConfigurationElement : ConfigurationElement
    {
        [ConfigurationProperty("storeName")]
        [TypeConverter(typeof (StoreNameEnumConverter))]
        public StoreName StoreName
        {
            get { return (StoreName) base["storeName"]; }
            set { base["storeName"] = value; }
        }

        [ConfigurationProperty("storeLocation")]
        [TypeConverter(typeof (StoreLocationEnumConverter))]
        public StoreLocation StoreLocation
        {
            get { return (StoreLocation) base["storeLocation"]; }
            set { base["storeLocation"] = value; }
        }

        [ConfigurationProperty("certDistinguishedName")]
        public string CertDistinguishedName
        {
            get { return (string) base["certDistinguishedName"]; }
            set { base["certDistinguishedName"] = value; }
        }
    }
}