using System.Configuration;

namespace SecurityTokenService.Configuration
{
    public class SecurityConfigurationElement : ConfigurationElement
    {
        /// <summary>
        /// Issuer Token Certificate
        /// </summary>
        [ConfigurationProperty("issuerCertificate")]
        public SecurityCertificateConfigurationElement IssuerCertificate
        {
            get { return (SecurityCertificateConfigurationElement) base["issuerCertificate"]; }
            set { base["issuerCertificate"] = value; }
        }

        /// <summary>
        /// Target Service Certificate
        /// </summary>
        [ConfigurationProperty("targetCertificate")]
        public SecurityCertificateConfigurationElement TargetCertificate
        {
            get { return (SecurityCertificateConfigurationElement) base["targetCertificate"]; }
            set { base["targetCertificate"] = value; }
        }

        /// <summary>
        /// Authorization catalog name
        /// </summary>
        [ConfigurationProperty("authorizationCatalogName")]
        public string AuthorizationCatalogName
        {
            get { return (string)base["authorizationCatalogName"]; }
            set { base["authorizationCatalogName"] = value; }
        }
    }
}