using System;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel;
using System.ServiceModel.Security;

namespace SecurityTokenService
{
    internal class Program
    {
        public static void Main(string[] args)
        {
            try
            {
                ExecuteService();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                Console.ReadKey();
            }
        }

        private static void ExecuteService()
        {
            using (ServiceHost stsServiceHost =
                new ServiceHost(typeof (STSUsingASPNETRoleProviderImplementation)))
            {
                stsServiceHost.Credentials.IssuedTokenAuthentication.CertificateValidationMode =
                    X509CertificateValidationMode.None;
                stsServiceHost.Credentials.IssuedTokenAuthentication.RevocationMode = X509RevocationMode.NoCheck;
                stsServiceHost.Open();

                Console.WriteLine("[Security Token Service is listening for connections]");
                Console.WriteLine("Press any key to shutdown...");
                Console.ReadKey();

                stsServiceHost.Close();
            }
        }
    }
}