using System;
using System.Collections.Generic;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel;
using System.ServiceModel.Security;
using System.Text;

namespace Service
{
    class Program
    {
        public static void Main(string[] args)
        {
            try
            {
                ExecuteService();
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex.Message);
                Console.ReadKey();
            }
        }

        private static void ExecuteService()
        {
            using(ServiceHost securedServiceHost =
                    new ServiceHost(typeof(SecuredService)))
            {
                securedServiceHost.Credentials.IssuedTokenAuthentication.CertificateValidationMode =
                    X509CertificateValidationMode.None;
                securedServiceHost.Credentials.IssuedTokenAuthentication.RevocationMode = X509RevocationMode.NoCheck;
                
                securedServiceHost.Open();

                Console.WriteLine("[Secured Service is listening for connections]");
                Console.WriteLine("Press any key to shutdown...");
                Console.ReadKey();

                securedServiceHost.Close();
            }
        }

    }
}
