using System;
using System.Security.Permissions;
using System.Threading;

namespace Service
{
    public class SecuredService : ISecuredService
    {
        #region ISecuredService Members

        [PrincipalPermission(SecurityAction.Demand, Role = "Administrator")]
        [PrincipalPermission(SecurityAction.Demand, Role = "User")]
        public string GetMyIdentity()
        {
            string calledIdentityName = Thread.CurrentPrincipal.Identity.Name;
            Console.WriteLine("Caller identity name is {0}", calledIdentityName);

            return calledIdentityName;
        }

        [PrincipalPermission(SecurityAction.Demand, Role = "Administrator")]
        public string DoSomethingAsAdministrator()
        {
            string result = 
                string.Format("{0} you are a valid administrator.", GetMyIdentity());

            Console.WriteLine("DoSomethingAsAdministrator returns {0}", result);
            
            return result;
        }

        [PrincipalPermission(SecurityAction.Demand, Role = "User")]
        public string DoSomethingAsRegularUser()
        {
            string result =
                string.Format("{0} you are a valid user.", GetMyIdentity());

            Console.WriteLine("DoSomethingAsRegularUser returns {0}", result);

            return result;
        }

        #endregion
    }
}